function [residual, g1, g2, g3] = lwz_model_dynamic(y, x, params, it_)
%
% Status : Computes dynamic model for Dynare
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(35, 1);
g = 1+params(4)/100;
lambda_qbar = 1+0.01*params(5);
lambda_kbar = g*lambda_qbar;
delta = 1-(1-params(9))*lambda_kbar;
betaparam = (params(10)*(1.0-g*params(11)/params(7))+params(8)*(1.0-g*params(11)/(lambda_kbar*params(7))))/(params(6)+params(10)*(1.0-params(11))+params(8)*(1.0-delta-params(11))/lambda_kbar);
lambda_abar = g/(params(7)*betaparam)-1.0;
muboe = betaparam*lambda_abar/g;
phi = params(10)*(1.0-betaparam*(1.0+params(11)*lambda_abar))/(params(6)*betaparam);
iy = params(9)*params(8);
by = params(10)*g*params(11)+params(8)*params(11)/lambda_qbar;
ceOY = params(6)-iy-by*(1-betaparam*(1+lambda_abar))/g;
chOY = 1-ceOY-iy;
lhOle = params(12)/params(10);
le = params(14)/(1.0+lhOle);
lh = params(14)-le;
omegah = (g-params(1))*(g-betaparam*(1+lambda_abar)*params(1));
omegae = (g-betaparam*params(2))*(g-params(2));
T116 = g^2+(1+lambda_abar)*betaparam*params(1)^2;
T169 = g^2+betaparam*params(2)^2;
T197 = params(3)*lambda_kbar^2;
T206 = lambda_kbar^2*betaparam*params(3);
T217 = params(11)*muboe/lambda_qbar;
T224 = betaparam*(1-delta)/lambda_kbar;
T240 = params(6)*betaparam*(1-phi)*1/params(8);
T268 = 1/(1+lambda_abar);
T284 = params(6)*(1-phi)/(1-params(6)*(1-phi));
T290 = (1-delta)/lambda_kbar;
T335 = 1-g*params(11)*params(10)/by;
T407 = chOY/(ceOY+chOY);
T409 = ceOY/(ceOY+chOY);
T456 = (-(g*params(11)*params(10)/by));
lhs =omegah*y(16);
rhs =(-T116)*y(25)+g*params(1)*(y(3)-y(32))-(g-params(1))*betaparam*lambda_abar*params(1)*y(61)+params(1)*g*betaparam*(1+lambda_abar)*(y(56)+y(59));
residual(1)= lhs-rhs;
lhs =y(16)+y(17);
rhs =y(41);
residual(2)= lhs-rhs;
lhs =y(16)+y(18);
rhs =betaparam*(1+lambda_abar)*(y(51)+y(52))+(1-betaparam*(1+lambda_abar))*(y(40)-y(28))+betaparam*lambda_abar*y(61);
residual(3)= lhs-rhs;
lhs =y(16)-y(19);
rhs =y(51)+y(61)*lambda_abar/(1+lambda_abar)-y(59);
residual(4)= lhs-rhs;
lhs =omegae*y(20);
rhs =(-T169)*y(26)+g*params(2)*(y(4)-y(32))+params(2)*g*betaparam*(y(59)+y(57));
residual(5)= lhs-rhs;
lhs =y(17);
rhs =y(24)-y(22);
residual(6)= lhs-rhs;
lhs =y(27);
rhs =(1+betaparam)*params(3)*lambda_kbar^2*y(23)-T197*y(2)+T197*(y(32)+y(34))-T206*(y(59)+y(54)+y(60));
residual(7)= lhs-rhs;
lhs =y(20)+y(27);
rhs =T217*(y(21)+y(42))+T224*(y(58)-y(60)-y(59))+(1-T217)*y(53)+T217*(y(58)-y(60))+T240*(y(55)-y(30));
residual(8)= lhs-rhs;
lhs =y(18)+y(20);
rhs =(y(21)+y(42))*params(11)*g*muboe+y(53)*(1-params(11)*g*muboe)+params(11)*g*muboe*(y(59)+y(52))+betaparam*y(52)+(1-betaparam-params(11)*betaparam*lambda_abar)*(y(55)-y(29));
residual(9)= lhs-rhs;
lhs =y(20)-y(19);
rhs =T268*(y(53)-y(59)+lambda_abar*y(21));
residual(10)= lhs-rhs;
lhs =y(24);
rhs =params(6)*phi*y(5)+params(6)*(1-phi)*y(6)+(1-params(6))*y(22)-T284*(y(34)+y(33));
residual(11)= lhs-rhs;
lhs =y(30);
rhs =T290*(y(6)-y(32)-y(34))+y(23)*(1-T290);
residual(12)= lhs-rhs;
lhs =y(24);
rhs =chOY*y(25)+ceOY*y(26)+iy*y(23);
residual(13)= lhs-rhs;
lhs =0;
rhs =y(28)*lh/params(14)+y(29)*le/params(14);
residual(14)= lhs-rhs;
lhs =params(6)*y(24);
rhs =ceOY*y(26)+iy*y(23)+params(10)*(y(29)-y(5))+by*1/g*(y(7)-y(32))-by*1/params(7)*(y(31)-y(19));
residual(15)= lhs-rhs;
lhs =y(31);
rhs =y(42)+g*params(11)*params(10)/by*(y(59)+y(52)+y(29))+T335*(y(58)+y(30)-y(60));
residual(16)= lhs-rhs;
lhs =y(33);
rhs =y(35)+y(36)-y(9);
residual(17)= lhs-rhs;
lhs =y(34);
rhs =y(37)+y(38)-y(11);
residual(18)= lhs-rhs;
lhs =y(32);
rhs =y(33)*1/(1-params(6)*(1-phi))+y(34)*T284;
residual(19)= lhs-rhs;
lhs =y(35);
rhs =params(15)*y(8)+x(it_, 4);
residual(20)= lhs-rhs;
lhs =y(36);
rhs =y(9)*params(16)+x(it_, 5);
residual(21)= lhs-rhs;
lhs =y(37);
rhs =params(17)*y(10)+x(it_, 6);
residual(22)= lhs-rhs;
lhs =y(38);
rhs =y(11)*params(18)+x(it_, 7);
residual(23)= lhs-rhs;
lhs =y(39);
rhs =params(19)*y(12)+x(it_, 1);
residual(24)= lhs-rhs;
lhs =y(40);
rhs =params(20)*y(13)+x(it_, 2);
residual(25)= lhs-rhs;
lhs =y(41);
rhs =params(21)*y(14)+x(it_, 3);
residual(26)= lhs-rhs;
lhs =y(42);
rhs =params(22)*y(15)+x(it_, 8);
residual(27)= lhs-rhs;
lhs =y(49);
rhs =y(25)*T407+y(26)*T409;
residual(28)= lhs-rhs;
lhs =y(43);
rhs =y(32)+y(18)-y(1)+log(g);
residual(29)= lhs-rhs;
lhs =y(44);
rhs =y(34)+log(lambda_qbar);
residual(30)= lhs-rhs;
lhs =y(45);
rhs =y(32)+log(g)+T407*(y(25)-y(3))+T409*(y(26)-y(4));
residual(31)= lhs-rhs;
lhs =y(46);
rhs =y(32)+log(g)+y(23)-y(2);
residual(32)= lhs-rhs;
lhs =y(47);
rhs =y(32)+log(g)+y(31)-y(7);
residual(33)= lhs-rhs;
lhs =y(48);
rhs =y(22)+log(params(13));
residual(34)= lhs-rhs;
lhs =y(50);
rhs =iy*y(46)+y(45)*(1-iy);
residual(35)= lhs-rhs;
if nargout >= 2,
  g1 = zeros(35, 69);

%
% Jacobian matrix
%

g1(1,16)=omegah;
g1(1,3)=(-(g*params(1)));
g1(1,25)=T116;
g1(1,56)=(-(params(1)*g*betaparam*(1+lambda_abar)));
g1(1,32)=g*params(1);
g1(1,59)=(-(params(1)*g*betaparam*(1+lambda_abar)));
g1(1,61)=(g-params(1))*betaparam*lambda_abar*params(1);
g1(2,16)=1;
g1(2,17)=1;
g1(2,41)=(-1);
g1(3,16)=1;
g1(3,51)=(-(betaparam*(1+lambda_abar)));
g1(3,18)=1;
g1(3,52)=(-(betaparam*(1+lambda_abar)));
g1(3,28)=1-betaparam*(1+lambda_abar);
g1(3,61)=(-(betaparam*lambda_abar));
g1(3,40)=(-(1-betaparam*(1+lambda_abar)));
g1(4,16)=1;
g1(4,51)=(-1);
g1(4,19)=(-1);
g1(4,59)=1;
g1(4,61)=(-(lambda_abar/(1+lambda_abar)));
g1(5,20)=omegae;
g1(5,4)=(-(g*params(2)));
g1(5,26)=T169;
g1(5,57)=(-(params(2)*g*betaparam));
g1(5,32)=g*params(2);
g1(5,59)=(-(params(2)*g*betaparam));
g1(6,17)=1;
g1(6,22)=1;
g1(6,24)=(-1);
g1(7,2)=T197;
g1(7,23)=(-((1+betaparam)*params(3)*lambda_kbar^2));
g1(7,54)=T206;
g1(7,27)=1;
g1(7,32)=(-T197);
g1(7,59)=T206;
g1(7,34)=(-T197);
g1(7,60)=T206;
g1(8,20)=1;
g1(8,53)=(-(1-T217));
g1(8,21)=(-T217);
g1(8,55)=(-T240);
g1(8,27)=1;
g1(8,58)=(-(T217+T224));
g1(8,30)=T240;
g1(8,59)=T224;
g1(8,60)=(-((-T224)-T217));
g1(8,42)=(-T217);
g1(9,18)=1;
g1(9,52)=(-(betaparam+params(11)*g*muboe));
g1(9,20)=1;
g1(9,53)=(-(1-params(11)*g*muboe));
g1(9,21)=(-(params(11)*g*muboe));
g1(9,55)=(-(1-betaparam-params(11)*betaparam*lambda_abar));
g1(9,29)=1-betaparam-params(11)*betaparam*lambda_abar;
g1(9,59)=(-(params(11)*g*muboe));
g1(9,42)=(-(params(11)*g*muboe));
g1(10,19)=(-1);
g1(10,20)=1;
g1(10,53)=(-T268);
g1(10,21)=(-(lambda_abar*T268));
g1(10,59)=T268;
g1(11,22)=(-(1-params(6)));
g1(11,24)=1;
g1(11,5)=(-(params(6)*phi));
g1(11,6)=(-(params(6)*(1-phi)));
g1(11,33)=T284;
g1(11,34)=T284;
g1(12,23)=(-(1-T290));
g1(12,6)=(-T290);
g1(12,30)=1;
g1(12,32)=T290;
g1(12,34)=T290;
g1(13,23)=(-iy);
g1(13,24)=1;
g1(13,25)=(-chOY);
g1(13,26)=(-ceOY);
g1(14,28)=(-(lh/params(14)));
g1(14,29)=(-(le/params(14)));
g1(15,19)=(-(by*1/params(7)));
g1(15,23)=(-iy);
g1(15,24)=params(6);
g1(15,26)=(-ceOY);
g1(15,5)=params(10);
g1(15,29)=(-params(10));
g1(15,7)=(-(by*1/g));
g1(15,31)=by*1/params(7);
g1(15,32)=by*1/g;
g1(16,52)=T456;
g1(16,58)=(-T335);
g1(16,29)=T456;
g1(16,30)=(-T335);
g1(16,31)=1;
g1(16,59)=T456;
g1(16,60)=T335;
g1(16,42)=(-1);
g1(17,33)=1;
g1(17,35)=(-1);
g1(17,9)=1;
g1(17,36)=(-1);
g1(18,34)=1;
g1(18,37)=(-1);
g1(18,11)=1;
g1(18,38)=(-1);
g1(19,32)=1;
g1(19,33)=(-(1/(1-params(6)*(1-phi))));
g1(19,34)=(-T284);
g1(20,8)=(-params(15));
g1(20,35)=1;
g1(20,65)=(-1);
g1(21,9)=(-params(16));
g1(21,36)=1;
g1(21,66)=(-1);
g1(22,10)=(-params(17));
g1(22,37)=1;
g1(22,67)=(-1);
g1(23,11)=(-params(18));
g1(23,38)=1;
g1(23,68)=(-1);
g1(24,12)=(-params(19));
g1(24,39)=1;
g1(24,62)=(-1);
g1(25,13)=(-params(20));
g1(25,40)=1;
g1(25,63)=(-1);
g1(26,14)=(-params(21));
g1(26,41)=1;
g1(26,64)=(-1);
g1(27,15)=(-params(22));
g1(27,42)=1;
g1(27,69)=(-1);
g1(28,25)=(-T407);
g1(28,26)=(-T409);
g1(28,49)=1;
g1(29,1)=1;
g1(29,18)=(-1);
g1(29,32)=(-1);
g1(29,43)=1;
g1(30,34)=(-1);
g1(30,44)=1;
g1(31,3)=T407;
g1(31,25)=(-T407);
g1(31,4)=T409;
g1(31,26)=(-T409);
g1(31,32)=(-1);
g1(31,45)=1;
g1(32,2)=1;
g1(32,23)=(-1);
g1(32,32)=(-1);
g1(32,46)=1;
g1(33,7)=1;
g1(33,31)=(-1);
g1(33,32)=(-1);
g1(33,47)=1;
g1(34,22)=(-1);
g1(34,48)=1;
g1(35,45)=(-(1-iy));
g1(35,46)=(-iy);
g1(35,50)=1;
end
if nargout >= 3,
%
% Hessian matrix
%

  g2 = sparse([],[],[],35,4761);
end
if nargout >= 4,
%
% Third order derivatives
%

  g3 = sparse([],[],[],35,328509);
end
end
